---
title: ':in-range'
slug: 'Web/CSS/:in-range'
tags:
  - CSS
  - Pseudo-class
  - Reference
  - Selector
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>:in-range</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/CSS/Pseudo-classes" title="Pseudo-classes">pseudo-class</a> represents an {{htmlelement("input")}} element whose current value is within the range limits specified by the {{htmlattrxref("min", "input")}} and {{htmlattrxref("max","input")}} attributes.</p>

<pre class="brush: css no-line-numbers notranslate">/* Selects any &lt;input&gt;, but only when it has a range
   specified, and its value is inside that range */
input:in-range {
  background-color: rgba(0, 255, 0, 0.25);
}</pre>

<p>This pseudo-class is useful for giving the user a visual indication that a field's current value is within the permitted limits.</p>

<div class="note"><strong>Note:</strong> This pseudo-class only applies to elements that have (and can take) a range limitation. In the absence of such a limitation, the element can neither be "in-range" nor "out-of-range."</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<div id="example">
<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;form action="" id="form1"&gt;
  &lt;ul&gt;Values between 1 and 10 are valid.
    &lt;li&gt;
      &lt;input id="value1" name="value1" type="number" placeholder="1 to 10" min="1" max="10" value="12" required&gt;
      &lt;label for="value1"&gt;Your value is &lt;/label&gt;
    &lt;/li&gt;
  &lt;/ul&gt;
&lt;/form&gt;</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css; notranslate">li {
  list-style: none;
  margin-bottom: 1em;
}

input {
  border: 1px solid black;
}

input:in-range {
  background-color: rgba(0, 255, 0, 0.25);
}

input:out-of-range {
  background-color: rgba(255, 0, 0, 0.25);
  border: 2px solid red;
}

input:in-range + label::after {
  content: 'okay.';
}

input:out-of-range + label::after {
  content: 'out of range!';
}</pre>

<h3 id="Result">Result</h3>
</div>

<p>{{EmbedLiveSample('Examples', 600, 140)}}</p>

<div class="notecard note">
<p><strong>Note</strong>: An empty <code>&lt;input&gt;</code> does not count as out of range, and will not be selected using the <code>:out-of-range</code> pseudo-class selector. The <code><a href="/en-US/docs/Web/CSS/:blank">:blank</a></code> pseudo-class exists to select blank inputs, although at the time of writing this is experimental and not well-supported. You could also use the <code>required</code> attribute and the <code><a href="/en-US/docs/Web/CSS/:invalid">:invalid</a></code> pseudo-class to provide more general logic and styling for making inputs mandatory (<code>:invalid</code> will style blank <em>and</em> out-of-range inputs).</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'scripting.html#selector-in-range', ':in-range')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Defines when <code>:in-range</code> matches elements in HTML.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS4 Selectors', '#in-range-pseudo', ':in-range')}}</td>
   <td>{{Spec2('CSS4 Selectors')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div>

<p>{{Compat("css.selectors.in-range")}}</p>
</div>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref(":out-of-range")}}</li>
 <li><a href="/en-US/docs/Learn/HTML/Forms/Form_validation">Form data validation</a></li>
</ul>
